// Copyright (C) 2024, Jakob Wakeling
// All rights reserved.

#ifndef DRAW_KEYS_H_YB0TUA76
#define DRAW_KEYS_H_YB0TUA76

typedef enum {
	DRAW_KEY_UNKNOWN       = -1,

	DRAW_KEY_SPACE         = 0x0020,
	DRAW_KEY_APOSTROPHE    = 0x0027,
	DRAW_KEY_COMMA         = 0x002c,
	DRAW_KEY_MINUS         = 0x002d,
	DRAW_KEY_PERIOD        = 0x002e,
	DRAW_KEY_SLASH         = 0x002f,

	DRAW_KEY_0             = 0x0030,
	DRAW_KEY_1             = 0x0031,
	DRAW_KEY_2             = 0x0032,
	DRAW_KEY_3             = 0x0033,
	DRAW_KEY_4             = 0x0034,
	DRAW_KEY_5             = 0x0035,
	DRAW_KEY_6             = 0x0036,
	DRAW_KEY_7             = 0x0037,
	DRAW_KEY_8             = 0x0038,
	DRAW_KEY_9             = 0x0039,

	DRAW_KEY_SEMICOLON     = 0x003b,
	DRAW_KEY_EQUAL         = 0x003d,

	DRAW_KEY_A             = 0x0041,
	DRAW_KEY_B             = 0x0042,
	DRAW_KEY_C             = 0x0043,
	DRAW_KEY_D             = 0x0044,
	DRAW_KEY_E             = 0x0045,
	DRAW_KEY_F             = 0x0046,
	DRAW_KEY_G             = 0x0047,
	DRAW_KEY_H             = 0x0048,
	DRAW_KEY_I             = 0x0049,
	DRAW_KEY_J             = 0x004a,
	DRAW_KEY_K             = 0x004b,
	DRAW_KEY_L             = 0x004c,
	DRAW_KEY_M             = 0x004d,
	DRAW_KEY_N             = 0x004e,
	DRAW_KEY_O             = 0x004f,
	DRAW_KEY_P             = 0x0050,
	DRAW_KEY_Q             = 0x0051,
	DRAW_KEY_R             = 0x0052,
	DRAW_KEY_S             = 0x0053,
	DRAW_KEY_T             = 0x0054,
	DRAW_KEY_U             = 0x0055,
	DRAW_KEY_V             = 0x0056,
	DRAW_KEY_W             = 0x0057,
	DRAW_KEY_X             = 0x0058,
	DRAW_KEY_Y             = 0x0059,
	DRAW_KEY_Z             = 0x005a,

	DRAW_KEY_LEFT_BRACKET  = 0x005b,
	DRAW_KEY_BACKSLASH     = 0x005c,
	DRAW_KEY_RIGHT_BRACKET = 0x005d,
	DRAW_KEY_TILDE         = 0x0060,

	DRAW_KEY_ESCAPE	       = 0x0100,
	DRAW_KEY_BACKSPACE     = 0x0101,
	DRAW_KEY_TAB           = 0x0102,
	DRAW_KEY_CAPS_LOCK     = 0x0103,
	DRAW_KEY_ENTER         = 0x0104,

	DRAW_KEY_F1            = 0x0105,
	DRAW_KEY_F2            = 0x0106,
	DRAW_KEY_F3            = 0x0107,
	DRAW_KEY_F4            = 0x0108,
	DRAW_KEY_F5            = 0x0109,
	DRAW_KEY_F6            = 0x010a,
	DRAW_KEY_F7            = 0x010b,
	DRAW_KEY_F8            = 0x010c,
	DRAW_KEY_F9            = 0x010d,
	DRAW_KEY_F10           = 0x010e,
	DRAW_KEY_F11           = 0x010f,
	DRAW_KEY_F12           = 0x0110,
	DRAW_KEY_F13           = 0x0111,
	DRAW_KEY_F14           = 0x0112,
	DRAW_KEY_F15           = 0x0113,
	DRAW_KEY_F16           = 0x0114,
	DRAW_KEY_F17           = 0x0115,
	DRAW_KEY_F18           = 0x0116,
	DRAW_KEY_F19           = 0x0117,
	DRAW_KEY_F20           = 0x0118,
	DRAW_KEY_F21           = 0x0119,
	DRAW_KEY_F22           = 0x011a,
	DRAW_KEY_F23           = 0x011b,
	DRAW_KEY_F24           = 0x011c,

	DRAW_KEY_SYSRQ         = 0x011d,
	DRAW_KEY_SCROLL_LOCK   = 0x011e,
	DRAW_KEY_PAUSE         = 0x011f,
	DRAW_KEY_INSERT        = 0x0120,
	DRAW_KEY_DELETE        = 0x0121,
	DRAW_KEY_HOME          = 0x0122,
	DRAW_KEY_END           = 0x0123,
	DRAW_KEY_PAGE_UP       = 0x0124,
	DRAW_KEY_PAGE_DOWN     = 0x0125,
	DRAW_KEY_LEFT          = 0x0126,
	DRAW_KEY_RIGHT         = 0x0127,
	DRAW_KEY_UP            = 0x0128,
	DRAW_KEY_DOWN          = 0x0129,

	DRAW_KEY_NUM_LOCK      = 0x0200,
	DRAW_KEY_KP_SLASH      = 0x0201,
	DRAW_KEY_KP_ASTERISK   = 0x0202,
	DRAW_KEY_KP_MINUS      = 0x0203,
	DRAW_KEY_KP_PLUS       = 0x0204,
	DRAW_KEY_KP_ENTER      = 0x0205,
	DRAW_KEY_KP_0          = 0x0210,
	DRAW_KEY_KP_1          = 0x0211,
	DRAW_KEY_KP_2          = 0x0212,
	DRAW_KEY_KP_3          = 0x0213,
	DRAW_KEY_KP_4          = 0x0214,
	DRAW_KEY_KP_5          = 0x0215,
	DRAW_KEY_KP_6          = 0x0216,
	DRAW_KEY_KP_7          = 0x0217,
	DRAW_KEY_KP_8          = 0x0218,
	DRAW_KEY_KP_9          = 0x0219,
	DRAW_KEY_KP_DOT        = 0x021a,

	DRAW_KEY_LEFT_SHIFT    = 0x0f00,
	DRAW_KEY_LEFT_CONTROL  = 0x0f01,
	DRAW_KEY_LEFT_ALT      = 0x0f02,
	DRAW_KEY_LEFT_SUPER    = 0x0f03,
	DRAW_KEY_RIGHT_SHIFT   = 0x0f04,
	DRAW_KEY_RIGHT_CONTROL = 0x0f05,
	DRAW_KEY_RIGHT_ALT     = 0x0f06,
	DRAW_KEY_RIGHT_SUPER   = 0x0f07,
} draw_key_k;

#endif // DRAW_KEYS_H_YB0TUA76
